#include "libscl.h";

using namespace std;
using namespace scl;

int main(int argc, char** argp, char** envp)
{
  // You can use a vector of strings to manage the argument list
  // and the environment list.
 
  vector<string> arguments;
  vector<string> environment;

  char** strptr = argp;

  for (int i=0; i<argc; ++i) {
    arguments.push_back(*strptr++);
  }

  strptr = envp;

  while (*strptr) {
    environment.push_back(*strptr++);
  }

  vector<string>::size_type idx;
  
  cout << starbox("/arguments//");

  for (idx = 0; idx < arguments.size(); ++idx) {
    cout << arguments[idx] << '\n';
  }

  cout << starbox("/environment//");

  for (idx = 0; idx < environment.size(); ++idx) {
    cout << environment[idx]<< '\n';
  }

  return 0;
}
